program DebugRuntime;

{$APPTYPE CONSOLE}

uses
  Windows;

function IsDirectXDebugInstalled: Boolean;
var
  Key: HKEY;
  dwValue: DWORD;
  dwBufLen: DWORD;
begin
  // Returns true if the DirectX DLL's are insatlled, false if not.
  // Reads the regkey:
  //
  // HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Direct3D\LoadDebugRuntime

  dwBufLen:= SizeOf(dwValue);

  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Direct3D', 0,
                   KEY_QUERY_VALUE, Key) <> ERROR_SUCCESS) then
  begin
    Result:= False;
    Exit;
  end;

  if (RegQueryValueEx(Key, 'LoadDebugRuntime', nil, nil,
                      @dwValue, @dwBufLen) <> ERROR_SUCCESS) then
  begin
    RegCloseKey(Key);
    Result:= False;
    Exit;
  end;

  RegCloseKey(Key);

  Result:= (dwValue <> 0);
end;

begin
  WriteLn('Checking is debug Direct3D8 or Direct3D9 runtime activated:');
  if IsDirectXDebugInstalled
  then WriteLn('Yes, it''s really activated.')
  else WriteLn('No, we are running against retail libs.');

  ReadLn;
end.
